<?php
require_once('facebook_app.php');
require_once('config.php');
require_once('vb_api_client.php');

FacebookApp::instance();

if(!(!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strstr($_SERVER['HTTP_X_REQUESTED_WITH'], 'XMLHttpRequest'))) {
    header('HTTP/1.1 404 Not Found');
    header('Connection: close');
    exit;
}

if( empty($_POST['username']) || empty($_POST['password'])) {
    header('HTTP/1.1 404 Not Found');
    header('Connection: close');
    exit;
}

$post['vb_login_username'] = $_POST['username'];
$post['vb_login_password'] = $_POST['password'];

$results = json_decode(VBApiClient::instance()->login($post), true);
error_log(json_encode($results));
$error_messages = array(
    'redirect_login' => array(true, false, 'Login successful!'),
    'badlogin' => array(false, true, 'Unable to login with those credentials.'),
    'badlogin_strikes' => array(false, true, 'Unable to login with those credentials.')
);   

if(isset($results['response']['errorlist'])) {
    $error_message = array();
    foreach($results['response']['errorlist'] as $error) {
        $error_return = @$error_messages[$error[0]];
        if(isset($error_return)) {
            $error_message[] = $error_return;
        } else {
            $error_message[] = array(false, true, $error[0]);
        }
    }
    $final_redirect = false;
    $final_error = true;
    $final_message = '';
    foreach($error_message as $error_return) {
        $final_redirect = $final_redirect || $error_return[0];
        $final_error = $final_error && $error_return[1];
        $final_message .= $error_return[2] . '<br/>';
    }
    echo json_encode(array("redirect" => $final_redirect, "error" => $final_error, "message" => $final_message));
} else if(isset($results['response']['errormessage'])) {
    $errormessage = '';
    if(is_array($results['response']['errormessage'])) {
        $errormessage = $results['response']['errormessage'][0];
    } else {
        $errormessage = $results['response']['errormessage'];
    }
    $error_return = $error_messages[$errormessage];
    if(isset($error_return)) {
        echo json_encode(array("redirect" => $error_return[0], "error" => $error_return[1], "message" => $error_return[2]));
    } else {
        echo json_encode(array("redirect" => false, "error" => true, "message" => 'Unable to complete registration at this time, please try again later.'));
    }
} else {
     echo json_encode(array("redirect" => false, "error" => true, "message" => 'Unable to complete registration at this time, please try again later.'));
}
exit;
?>